unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image1: TImage;
    Button1: TButton;
    Shape1: TShape;
    Edit1: TEdit;
    Button2: TButton;
    Image2: TImage;
    Button3: TButton;
    Edit2: TEdit;
    Button4: TButton;
    Shape2: TShape;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
  Tarray=Array[1..600,1..600] Of integer;
  
   // Define our fractal class
   Tfractal = class
   private
     fractalName  : String;
     fractalPoints:Tarray;
   published
     // fractal properties
     property Name : String
       read  fractalName;
   public
	 property Points : Tarray
       read  fractalPoints 
       write fractalPoints;
 
     // fractal constructor
     constructor Create(name : String);
   end;
   
   Timage = class
   private
     imageName  : String;
     imagePoints:Tarray;
   published
     // fractal properties
     property Name : String
       read  imageName;
   public
	 property Points : Tarray
       read  imagePoints 
       write imagePoints;
 
     // fractal constructor
     constructor Create(name : String);
   end;
   
      // An interface definition
   Ipoints = Interface(IInterface)
     // A single function supporting the property
     function getPointsFcn : Tarray;
     // A single property
     property getPoints : Tarray read getPointsFcn;
   end;
   
var
  Form1: TForm1;
  koord2,koord:Array[1..100,1..3] Of Real;
  k,k2,n1,n2:Longint;
  cx,cy:Real;

implementation

{$R *.dfm}

constructor Tfractal.Create(name : String);
begin
   // Save the fractal name
   fractalName  := name;
   // fractalPoints   := 0;
end;

constructor Timage.Create(name : String);
begin
   // Save the fractal name
   imageName  := name;
   // fractalPoints   := 0;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
      if edit1.Text='w' then
      shape1.Top:=shape1.Top-10;
      if edit1.Text='s' then
      shape1.Top:=shape1.Top+10;
      if edit1.Text='a' then
      shape1.left:=shape1.left-10;
      if edit1.Text='d' then
      shape1.left:=shape1.left+10;
      edit1.text:='';
end;

procedure TForm1.Button1Click(Sender: TObject);
Var
   x,y,x1,y1,t:Real;
   l,i,j:integer;
begin
   If k=0 Then k:=1
   Else Begin
   k:=k+1;
   koord[k,1]:=koord[k-1,1]+koord[k-1,3]/600*(shape1.Left-1);
   koord[k,2]:=koord[k-1,2]-koord[k-1,3]/600*(shape1.Top-1);
   koord[k,3]:=koord[k-1,3]*1/3;
   n1:=n1*3;
   label7.caption:=inttostr(n1);
   End;
   image1.Canvas.Rectangle(1,1,600,600);
   For i:=1 To 600 Do Begin
      x:=koord[k,3]/600*(i-1)+koord[k,1];
      For j:=1 To 600 Do
         Begin
            y:=koord[k,2]-koord[k,3]/600*(j-1);
            x1:=0;
            y1:=0;
            l:=0;
            While (x1*x1+y1*y1<4) And (l<200) Do
               Begin
                  t:=2*x1*y1+y;
                  x1:=x1*x1-y1*y1+x;
                  y1:=t;
                  l:=l+1
               End;
            image1.Canvas.Pixels[i,j]:=Round(l*100000);
         End;
   End;
   edit1.SetFocus;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var
   x,y,x1,y1,t:Real;
   l,i,j:integer;
begin
   If k>1 Then Begin
      k:=k-1;
      n1:=Round(n1/3);
   End;
   label7.caption:=inttostr(n1);
   image1.Canvas.Rectangle(1,1,600,600);
   For i:=1 To 600 Do Begin
      x:=koord[k,3]/600*(i-1)+koord[k,1];
      For j:=1 To 600 Do
         Begin
            y:=koord[k,2]-koord[k,3]/600*(j-1);
            x1:=0;
            y1:=0;
            l:=0;
            While (x1*x1+y1*y1<4) And (l<200) Do
               Begin
                  t:=2*x1*y1+y;
                  x1:=x1*x1-y1*y1+x;
                  y1:=t;
                  l:=l+1
               End;
            image1.Canvas.Pixels[i,j]:=Round(l*100000);
         End;
   End;
   edit1.SetFocus;
end;

procedure TForm1.Button3Click(Sender: TObject);
Var
   x,y,x1,y1,t:Real;
   l,i,j:integer;
begin
   cx:=strtoint(edit3.Text)/1000;
   cy:=strtoint(edit4.Text)/1000;
   If k2=0 Then k2:=1
   Else Begin
   k2:=k2+1;
   koord2[k2,1]:=koord2[k2-1,1]+koord2[k2-1,3]/600*(shape2.Left-1);
   koord2[k2,2]:=koord2[k2-1,2]-koord2[k2-1,3]/600*(shape2.Top-1);
   koord2[k2,3]:=koord2[k2-1,3]*1/3;
   n2:=n2*3;
   End;
   label8.caption:=inttostr(n2);
   image2.Canvas.Rectangle(1,1,600,600);
   For i:=1 To 600 Do Begin
      x:=koord2[k2,3]/600*(i-1)+koord2[k2,1];
      For j:=1 To 600 Do
         Begin
            y:=koord2[k2,2]-koord2[k2,3]/600*(j-1);
            x1:=x;
            y1:=y;
            l:=0;
            While (x1*x1+y1*y1<4) And (l<200) Do
               Begin
                  t:=2*x1*y1+cy;
                  x1:=x1*x1-y1*y1+cx;
                  y1:=t;
                  l:=l+1;
               End;
            image2.Canvas.Pixels[i,j]:=Round(l*100000);
         End;
   End;
   edit2.SetFocus;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
      if edit2.Text='w' then
      shape2.Top:=shape2.Top-10;
      if edit2.Text='s' then
      shape2.Top:=shape2.Top+10;
      if edit2.Text='a' then
      shape2.left:=shape2.left-10;
      if edit2.Text='d' then
      shape2.left:=shape2.left+10;
      edit2.text:='';
end;


procedure TForm1.Button4Click(Sender: TObject);
   Var
   x,y,x1,y1,t:Real;
   l,i,j:integer;
begin
   If k2>1 Then Begin
      k2:=k2-1;
      n2:=Round(n2/3);
      label8.caption:=inttostr(n2);
   End;
   image2.Canvas.Rectangle(1,1,600,600);
   For i:=1 To 600 Do Begin
      x:=koord2[k2,3]/600*(i-1)+koord2[k2,1];
      For j:=1 To 600 Do
         Begin
            y:=koord2[k2,2]-koord2[k2,3]/600*(j-1);
            x1:=x;
            y1:=y;
            l:=0;
            While (x1*x1+y1*y1<4) And (l<200) Do
               Begin
                  t:=2*x1*y1+cy;
                  x1:=x1*x1-y1*y1+cx;
                  y1:=t;
                  l:=l+1
               End;
            image2.Canvas.Pixels[i,j]:=Round(l*100000);
         End;
   End;
   edit2.SetFocus;
end;

Begin
   koord[1,1]:=-2;
   koord[1,2]:=2;
   koord[1,3]:=4;
   k:=0;
   koord2[1,1]:=-2;
   koord2[1,2]:=2;
   koord2[1,3]:=4;
   k2:=0;
   n1:=1;
   n2:=1;
end.
